<?xml version="1.0"?>
<ArrayOfFBEvent xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2024-01-02T16:15:34Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment>Verified with dp  versions 4.0.1070 ,4.1.468.49713,4.2.182 </Comment>
    <StatusString>Closed</StatusString>
    <TimeStamp>2023-10-12T23:31:55Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Closed</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>The attached scripts can be run on DataPRO databases to solve this problem.

They are run as part of the migration from database Version 93 to 94, but if the database is already at Version 94, they will need to be run manually.

They are safe to run if one or more have already been run. For example, "Alter_Settings_90_..." is run when migrating from Version 90 to 91.</Comment>
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-08-29T18:06:53Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>ReleaseNoted</StatusString>
    <TimeStamp>2023-07-18T21:35:30Z</TimeStamp>
    <ReleaseNote>Addresses an issue with Copy from remote server</ReleaseNote>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-07-13T15:32:46Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>49171 is 4.0; 49172 is 4.1; 49173 is 4.2
To test:
Install 3.3.797 so that the database is Version 88.
Install 4.0.945 so that the database is migrated to version 93.
Verify that the LastUsedHardware, Settings, and UIItemSettings tables do not have an ID field.
Install a version of DataPRO with this fix, so that the database is migrated to Version 94.
Verify that the tables now all have an ID field and that it is the Primary Key for the table.</Comment>
    <StatusString>Resolved</StatusString>
    <TimeStamp>2023-07-12T18:43:27Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Resolved</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-07-12T18:39:52Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>Reopened to handle case where ID field does not exist because db was migrated from Version 90 prior to a patch that added the ID fields to the LastUsedHardware, Settings, and UIItemSettings tables.</Comment>
    <StatusString>Reopened</StatusString>
    <TimeStamp>2023-07-12T15:55:21Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment>Verified with Datapro versions 4.0.49123 , 4.1.335.49135 and  4.2.13.
Installed each version  of datapro with dbtype set to 0  to migrate central db  on asada to installed version. Then set dbtype to 2  logged in , navigate to system settings&gt;database&gt; copy to local , and did not see any errors.  Then I switched to local and verified db matched original .
 </Comment>
    <StatusString>Closed</StatusString>
    <TimeStamp>2023-06-22T23:34:57Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Closed</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-22T23:30:56Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-22T23:23:48Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-22T23:19:37Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-22T23:19:10Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment>Success on 4.0 .972.49130  case closed for 4.0.972 version 

case 31867

</Comment>
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-22T22:37:38Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-06-22T22:00:13Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>49130 is 4.0; 49131 is 4.1; 49132 is 4.2</Comment>
    <StatusString>Resolved</StatusString>
    <TimeStamp>2023-06-22T20:57:48Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Resolved</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Resolved</StatusString>
    <TimeStamp>2023-06-22T20:57:03Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Resolved</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>Failed to modify the LastUsedHardware and UIItemSettings tables.</Comment>
    <StatusString>Reactivated</StatusString>
    <TimeStamp>2023-06-22T20:56:54Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Reactivated</Status>
  </FBEvent>
  <FBEvent>
    <User>Justin Richardson</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-06-22T17:01:06Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>49123 is 4.0; 49124 is 4.1; 49125 is 4.2</Comment>
    <StatusString>Resolved</StatusString>
    <TimeStamp>2023-06-21T15:36:57Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Resolved</Status>
  </FBEvent>
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>ReleaseNoted</StatusString>
    <TimeStamp>2023-06-20T18:12:13Z</TimeStamp>
    <ReleaseNote>Addresses an issue with Copy from remove server</ReleaseNote>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>This bug was introduced in the work done for bug 17854.  I've attached the Word document from that issue here for more context, but the problem is that a database change was made (adding the ID field, and making it a Primary Key, to the Settings table), but not accounted for in a migration script.

Therefore, if a database was migrated from an earlier database version, the change would be lost, thereby causing the error shown in this issue.

To test:
Migrate Local DataPRO database from 3.3 to 4.0.
Copy the migrated database to a Centralized server.
Set DbType=2 (Both), LocalDbHost=&lt;server name&gt;, and UseNTLMAuthentication=True.
Run DataPRO.
Go to the System Settings | Database step and click on the “Copy from remote server to local” button.
Without the patch during migration, the error should occur, and with the patch during migration, the copy should be successful.


</Comment>
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-06-20T15:30:35Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Dan McFadden</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-06-19T15:56:09Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Edited</StatusString>
    <TimeStamp>2023-06-07T23:23:20Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment />
    <StatusString>Assigned</StatusString>
    <TimeStamp>2023-06-07T23:22:39Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>UNKNOWN</Status>
  </FBEvent>
  <FBEvent>
    <User>Jerry Lawrence</User>
    <Comment>The error also occurs in 4.1.315.
</Comment>
    <StatusString>Opened</StatusString>
    <TimeStamp>2023-06-07T23:22:38Z</TimeStamp>
    <ZendeskNumber>0</ZendeskNumber>
    <Status>Opened</Status>
  </FBEvent>
</ArrayOfFBEvent>